%define as_major 5
%define as_minor 1
%define as_rev 1

%define ep5nativehomedir %{_datadir}/native
%define ep5nativedir %{_localstatedir}/lib/native
%define jbhomedir %{_localstatedir}/lib/jbossas

Summary:        JBoss EAP 5 native zip
Name:           jboss-eap5-native
Version:        %{as_major}.%{as_minor}.%{as_rev}
Release:        3%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Installer
URL:            http://www.jboss.org/

BuildRequires: jpackage-utils,zip,unzip

BuildRequires: httpd22-apr
BuildRequires: httpd22-apr-util
BuildRequires: tomcat-native >= 0:1.1.20
BuildRequires: mod_jk-ap20 >= 0:1.2.31
BuildRequires: mod_cluster-native >= 0:1.0.10
BuildRequires: hornetq-native >= 0:2.2.2
BuildRequires: java-devel
Requires:      tomcat-native >= 0:1.1.20
#The following should be Optional as they requires httpd22 from EWS
#Requires:      mod_jk-ap20
#Requires:      mod_cluster

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This package is a container for the EAP 5 native zip.

%package monolithic-zip
Summary:        Monolithic .zip for all of EAP 5 native bits
Group:          Development

%description monolithic-zip
Monolithic .zip for all of EAP 5 native bits

%prep

%build
mkdir jboss-ep-%{as_major}.%{as_minor}
pushd jboss-ep-%{as_major}.%{as_minor}
%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif
    mkdir -p native/$libdir/httpd/modules
    # apr, tcnative, mod_jk
    cp -pL %{_libdir}/libapr*1* native/$libdir/
    cp -pL %{_libdir}/libtcnative* native/$libdir/
    cp -p %{_libdir}/httpd22/modules/mod_jk.so native/$libdir/httpd/modules/
    # mod_cluster
    cp -p %{_libdir}/httpd22/modules/mod_{slotmem,proxy_cluster,manager,advertise}.so native/$libdir/httpd/modules/
    # hornetq-native
    cp -pL %{_libdir}/libHornetQ* native/$libdir/
    chmod -R 755 native/$libdir/*
popd
zip -q -r -y jboss-ep-native-%{version}-RHEL4-%{_arch}.zip jboss-ep-%{as_major}.%{as_minor}
rm -rf jboss-ep-%{as_major}.%{as_minor}

%install
rm -rf $RPM_BUILD_ROOT
#install -dm 755 $RPM_BUILD_ROOT/%{ep5nativedir}/lib/httpd/modules
%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif
install -dm 755 $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir
install -dm 755 $RPM_BUILD_ROOT/%{_datadir}
install -dm 755 $RPM_BUILD_ROOT/%{jbhomedir}
(cd $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir && for i in `ls %{_libdir}/libtcnative*`; do ln -sf $i .; done)
cp -pL %{_libdir}/libapr*1* $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir/

#Optional as they requires httpd22
#( cd $RPM_BUILD_ROOT/%{ep5nativedir}/lib/httpd/modules && for i in mod_slotmem.so mod_proxy_cluster.so mod_manager.so mod_jk.so mod_advertise.so; do ln -sf %{_libdir}/httpd22/modules/$i .; done)

(cd $RPM_BUILD_ROOT/%{_datadir} && ln -sf %{ep5nativedir}/ native)

install -dm 755 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/
install -m 644 *.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev

%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{jbhomedir} -g jboss jboss 2>/dev/null || :

%files
%defattr(0644,jboss,jboss,0755)
%dir %{ep5nativehomedir}
%dir %{ep5nativedir}
%ifarch x86_64
%dir %{ep5nativedir}/lib64
%{ep5nativedir}/lib64/*
%else
%dir %{ep5nativedir}/lib
%{ep5nativedir}/lib/*
%endif
#Optional as they requires httpd22
#%dir %{ep5nativedir}/lib/httpd
#%dir %{ep5nativedir}/lib/httpd/modules
#%{ep5nativedir}/lib/httpd/modules/*

%files monolithic-zip
%defattr(-,root,root,-)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/*.zip

%changelog
* Fri Jun 11 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-3
- Rebuild to pick up latest mod_cluster-native-1.0.10.GA_CP01

* Thu May 19 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-2
- Rebuild to pick up latest apr with a fix for CVE-2011-1928

* Thu May 12 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-1
- Rebuild to pick up latest apr with a fix for CVE-2011-0419

* Tue Mar 29 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.4
- Rebuild to pick up hq-native 2.2.2

* Tue Mar 22 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.3
- Rebuild to pick up mod_cluster 1.0.9

* Thu Mar 17 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.2
- Fix jbhomedir (JBPAPP-5085)

* Mon Mar 14 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.1
- Build for EAP 5.1.1

* Thu Nov 25 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-13
- Rebuild to pick up mod_cluster-native 1.0.5

* Mon Sep 20 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-12
- Install 64 bit libraries at lib64 instead of lib

* Wed Aug 18 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-11
- Rebuild to pick up latest hornetq-native (2.1.2.Final)

* Wed Jul 28 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-10
- Rebuild to pick up mod_cluster-native 1.0.4

* Fri Jul 23 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-9
- Add define for jbhomedir

* Wed Jul 21 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-8
- Add the creation of jboss user and group

* Thu Jul 15 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-7
- Remove hornetq-native as a Requires because it is not needed for EWP,
  it should be a R: in the jbossas-hornetq package

* Thu Jun 24 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-6
- Rebuild with latest mod_cluster-native rebuild

* Tue Jun 22 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-5
- Rebuild with latest mod_cluster-native rebuild

* Fri Jun 18 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-4
- Rebuild with latest mod_cluster rebuild

* Wed Jun 16 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-3
- Build with latest hornetq-native (built from 2.1.1.Final)

* Fri Jun 04 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-2
- Build with latest hornetq-native (built from 2.1.0.Final)

* Thu Jun 03 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-1
- Add hornetq-native
- Rename top dir to jboss-ep
- BR mod_cluster-native instead of the zip

* Thu Apr 08 2010 Hui Wang <huwang@redhat.com> 5.0.1-5.1
- Rebuild

* Wed Mar 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-5
- Do not R: httpd22-apr* either as we cannot just ship the subpackages only

* Wed Mar 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-4
- Mark mod_jk and mod_cluster as optional as they R: httpd22 from EWS

* Tue Mar 16 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-3
- Fix directory structure

* Tue Mar 16 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-2
- Add main package for installation

* Thu Feb 11 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-1
- Build for EAP 5.0.1

* Mon Jan 25 2010 Permaine Cheung <pcheung@redhat.com> 5.0.0-14
- Rebuild

* Tue Jan 19 2010 Permaine Cheung <pcheung@redhat.com> 5.0.0-13
- Use mod_cluster 1.0.3
- Fix names of the zips and permission on the libraries for mod_cluster

* Mon Dec 07 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-12
- Rebuild with jar signing

* Mon Dec 07 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-11
- Add more info to the README for mod_cluster

* Wed Nov 18 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-10
- Add Jar signing and README

* Fri Nov 06 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-9
- Change name of zip

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-8
- Separate server zip and add src zip for mod_cluster

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-7
- Add mod_cluster to the zip

* Fri Aug 07 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-6
- Rebuild to pick up latest apr, aprutil fixes

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-5
- Update directory structure

* Sun Jul 26 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-4
- Fix directory structure and add apr-util

* Fri Jul 24 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-3
- Fix name of zip

* Thu Jul 23 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-2
- Change directory structure and name of zip

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-1
- First build
- Include libapr as the one in base RHEL 4 is too old
